program Project2;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils,  Classes,
  FlexCel.VCLSupport, FlexCel.Core, FlexCel.XlsAdapter, IOUtils;

function GetExtension(const ImgType: TXlsImgType): string;
begin
  case ImgType of
    TXlsImgType.Bmp:
    begin
      exit('.bmp');
    end;
    TXlsImgType.Emf:
    begin
      exit('.emf');
    end;
    TXlsImgType.Jpeg:
    begin
      exit('.jpg');
    end;
    TXlsImgType.Wmf:
    begin
      exit('.wmf');
    end;
    TXlsImgType.Tiff:
    begin
      exit('.tif');
    end;
    TXlsImgType.Gif:
    begin
      exit('.gif');
    end;
    TXlsImgType.Png:
    begin
      exit('.png');
    end;
    else
    begin
      exit('');
    end;
  end;
end;

procedure GetAllImagesInSheet;
var
  xls: TXlsFile;
  imageType: TXlsImgType;
  i: Int32;
  filename: string;
  ImageStream: TFileStream;
begin
  xls := TXlsFile.Create('../../Report.xlsx');
  try
     //Get all the images in the active sheet and save them
     //as myimage1.png, myimage2.jpeg, etc depending in the
     //image type.
    imageType := TXlsImgType.Unknown;
    for i := 1 to xls.ImageCount do
    begin
      var Anchor := xls.GetImageProperties(i).Anchor;

      WriteLn('Row1: ', Anchor.Row1);
      WriteLn('DY1: ', Anchor.Dy1);

      filename := 'myimage' + IntToStr(i);
      ImageStream := TFileStream.Create(filename, fmCreate);
      try
        xls.GetImage(i, imageType, ImageStream);
      finally
        ImageStream.Free;
      end;
      deletefile(TPath.ChangeExtension(filename, GetExtension(imageType)));
      TFile.Move(filename, TPath.ChangeExtension(filename, GetExtension(imageType)));
    end;
  finally
    xls.Free;
  end;

end;

begin
  GetAllImagesInSheet;
  readln;
end.
